summaryrefslogtreecommitdiff
path: root/src
diff options
context:
space:
mode:
authorBrian Mattern <rephorm@rephorm.com>2012-09-11 22:21:21 -0700
committerJason A. Donenfeld <Jason@zx2c4.com>2012-09-12 12:38:48 +0200
commit2ac8b6577f806b8bd4cbc103d2837ebed68f6778 (patch)
treec36b5d548bf22f4df95ef6aaf5b6d2076f10b877 /src
parent3a0c8bae77a15976f6b74ed92d57127f7d6cdca6 (diff)
downloadpass-2ac8b6577f806b8bd4cbc103d2837ebed68f6778.tar.gz
pass-2ac8b6577f806b8bd4cbc103d2837ebed68f6778.tar.bz2
pass-2ac8b6577f806b8bd4cbc103d2837ebed68f6778.zip
Use getopt to regularize options
I like being able to specify command line options (like -c) at the end of the line (which is usually when I think of the fact that I need them). The attached patch uses getopt(1) to regularize the option list so that lazy people like me can specify the options in any order.
Diffstat (limited to '')
-rwxr-xr-xsrc/password-store.sh62
1 files changed, 35 insertions, 27 deletions
diff --git a/src/password-store.sh b/src/password-store.sh
index a89be8d..f9e13e4 100755
--- a/src/password-store.sh
+++ b/src/password-store.sh
@@ -115,10 +115,20 @@ fi
case "$command" in
show|ls|list)
clip=0
- if [[ $1 == "--clip" || $1 == "-c" ]]; then
- clip=1
- shift
+
+ opts="$(getopt -o c -l clip -n $program -- "$@")"
+ err=$?
+ eval set -- "$opts"
+ while true; do case $1 in
+ -c|--clip) clip=1; shift ;;
+ --) shift; break ;;
+ esac done
+
+ if [[ $err -ne 0 ]]; then
+ echo "Usage: $program $command [--clip,-c] [pass-name]"
+ exit 1
fi
+
path="$1"
if [[ -d $PREFIX/$path ]]; then
if [[ $path == "" ]]; then
@@ -143,18 +153,17 @@ case "$command" in
insert)
ml=0
noecho=0
- while true; do
- if [[ $1 == "--multiline" || $1 == "-m" ]]; then
- ml=1
- shift
- elif [[ $1 == "--no-echo" || $1 == "-n" ]]; then
- noecho=1
- shift
- else
- break
- fi
- done
- if [[ ( $ml -eq 1 && $noecho -eq 1 ) || $# -ne 1 ]]; then
+
+ opts="$(getopt -o mn -l multiline,no-echo -n $program -- "$@")"
+ err=$?
+ eval set -- "$opts"
+ while true; do case $1 in
+ -m|--multiline) ml=1; shift ;;
+ -n|--no-echo) noecho=1; shift ;;
+ --) shift; break ;;
+ esac done
+
+ if [[ $err -ne 0 || ( $ml -eq 1 && $noecho -eq 1 ) || $# -ne 1 ]]; then
echo "Usage: $program $command [--no-echo,-n | --multiline,-m] pass-name"
exit 1
fi
@@ -241,18 +250,17 @@ case "$command" in
generate)
clip=0
symbols="-y"
- while true; do
- if [[ $1 == "--no-symbols" || $1 == "-n" ]]; then
- symbols=""
- shift
- elif [[ $1 == "--clip" || $1 == "-c" ]]; then
- clip=1
- shift
- else
- break
- fi
- done
- if [[ $# -ne 2 ]]; then
+
+ opts="$(getopt -o nc -l no-symbols,clip -n $program -- "$@")"
+ err=$?
+ eval set -- "$opts"
+ while true; do case $1 in
+ -n|--no-symbols) symbols=""; shift ;;
+ -c|--clip) clip=1; shift ;;
+ --) shift; break ;;
+ esac done
+
+ if [[ $err -ne 0 || $# -ne 2 ]]; then
echo "Usage: $program $command [--no-symbols,-n] [--clip,-c] pass-name pass-length"
exit 1
fi
> 2006-12-11Move global variables + callback functions into shared.cLars Hjemli4-82/+86 Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-11Move functions for generic object output into ui-view.cLars Hjemli4-34/+43 Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-11Move log-functions into ui-log.cLars Hjemli5-111/+121 Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-11Move repo summary functions into ui-summary.cLars Hjemli4-47/+59 Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-11Move functions for repolist output into ui-repolist.cLars Hjemli5-70/+90 Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-11Move common output-functions into ui-shared.cLars Hjemli4-82/+99 While at it, replace the cgit_[lib_]error constants with a proper function Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-11Rename config.c to parsing.c + move cgit_parse_query from cgit.c to parsing.cLars Hjemli4-28/+29 Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-11Avoid infinite loops in caching layerLars Hjemli3-14/+31 Add a global variable, cgit_max_lock_attemps, to avoid the possibility of infinite loops when failing to acquire a lockfile. This could happen on broken setups or under crazy server load. Incidentally, this also fixes a lurking bug in cache_lock() where an uninitialized returnvalue was used. Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-11Let 'make install' clear all cachefilesLars Hjemli1-0/+2 Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-11Fix cache algorithm loopholeLars Hjemli3-11/+16 This closes the door for unneccessary calls to cgit_fill_cache(). Noticed by Linus. Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-10Add version identifier in generated filesLars Hjemli2-9/+14 Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-10Add license file and copyright noticesLars Hjemli5-0/+372 Signed-off-by: Lars Hjemli <hjemli@gmail.com> 2006-12-10Add caching infrastructureLars Hjemli9-28/+353 This enables internal caching of page output. Page requests are split into four groups: 1) repo listing (front page) 2) repo summary 3) repo pages w/symbolic references in query string 4) repo pages w/constant sha1's in query string Each group has a TTL specified in minutes. When a page is requested, a cached filename is stat(2)'ed and st_mtime is compared to time(2). If TTL has expired (or the file didn't exist), the cached file is regenerated. When generating a cached file, locking is used to avoid parallell processing of the request. If multiple processes tries to aquire the same lock, the ones who fail to get the lock serves the (expired) cached file. If the cached file don't exist, the process instead calls sched_yield(2) before restarting the request processing. Signed-off-by: Lars Hjemli <hjemli@gmail.com>